// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js
angular.module('app', []);

angular.module('starter.services',[]);

angular.module('starter', ['ionic', 'starter.controllers', 'starter.services','app'])

.run(function($ionicPlatform) {
     $ionicPlatform.ready(function() {
                          // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
                          // for form inputs)
                          if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
                          cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
                          cordova.plugins.Keyboard.disableScroll(true);
                          
                          }
                          if (window.StatusBar) {
                          // org.apache.cordova.statusbar required
                          StatusBar.styleLightContent();
                          }
                          });
     })

.config(function($ionicConfigProvider, $stateProvider, $urlRouterProvider) {
        
        // Ionic uses AngularUI Router which uses the concept of states
        // Learn more here: https://github.com/angular-ui/ui-router
        // Set up the various states which the app can be in.
        // Each state's controller can be found in controllers.js
        
        $ionicConfigProvider.tabs.position('bottom');
        
        $stateProvider
        
//                .state('login', {
//                       url: '/login',
//                       views: {
//                        '': {
//                            templateUrl: 'login.html',
//                            controller: 'LoginCtrl'
//                       }
//                       }
//                       })
        
        // setup an abstract state for the tabs directive
        .state('tab', {
               url: '/tab',
               abstract: true,
               templateUrl: 'templates/tabs.html'
               })
        
        // Each tab has its own nav history stack:
        
        .state('tab.achievement', {
               url: '/achievement',
               views: {
               'tab-achievement': {
               templateUrl: 'templates/tab-achievement.html',
               controller: 'AchievementCtrl'
               }
               }
               })
        
        .state('tab.statistic', {
               url: '/statistic',
               views: {
               'tab-statistic': {
               templateUrl: 'templates/tab-statistic.html',
               controller: 'StatisticCtrl'
               }
               }
               })
        
        
        .state('tab.chats', {
               url: '/chats',
               views: {
               'tab-chats': {
               templateUrl: 'templates/tab-chats.html',
               controller: 'ChatsCtrl'
               }
               }
               })
        .state('tab.chat-detail', {
               url: '/chats/:chatId',
               views: {
               'tab-chats': {
               templateUrl: 'templates/chat-detail.html',
               controller: 'ChatDetailCtrl'
               }
               }
               })
        
        .state('tab.account', {
               url: '/account',
               views: {
               'tab-account': {
               templateUrl: 'templates/tab-account.html',
               controller: 'AccountCtrl'
               }
               }
               })
        
        .state('tab.home', {
               url: '/home',
               views: {
               'tab-home': {
               templateUrl: 'templates/tab-home.html',
               controller: 'HomeCtrl'
               }
               }
               })
        .state('tab.setting', {
               url: '/setting',
               views: {
               'tab-setting': {
               templateUrl: 'templates/tab-setting.html',
               controller: 'SettingCtrl'
               }
               }
               })
        .state('tab.game', {
               url: '/game',
               views: {
               'tab-game': {
               templateUrl: 'templates/tab-game.html',
               controller: 'GameCtrl'
               }
               }
               })
        .state('login', {
               url: '/login',
               controller: 'LoginCtrl',
               templateUrl: 'login.html'});
        
        
        // if none of the above states are matched, use this as the fallback
        $urlRouterProvider.otherwise('/login');
//          $urlRouterProvider.otherwise('/login');
        
        });
