'use strict';
angular
  .module( 'app.bar', [] )
  .controller( 'BarCtrl', function ( $scope ) {

  // window.alert("abc");

    $scope.data = {
      labels: ['Sun','Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat'],
      datasets: [
        {
          label: 'Weekly Intake',
          fillColor: 'rgba(151,187,205,0.5)',
          strokeColor: 'rgba(151,187,205,0.8)',
          highlightFill: 'rgba(151,187,205,0.75)',
          highlightStroke: 'rgba(151,187,205,1)',
          data: [0, 0, 0, 0, 0, 0, 0]
        }
      ]
    };

    // x axis(dates)
    var dateArray = new Array();
    var today = new Date();
    // var today_str = today.getMonth()+ 1 +"/"+ today.getDate() - 7;
    
    for (var i = 0; i < 7; i++){
      var temp_date = new Date();
      temp_date.setDate(temp_date.getDate() - (6-i));
      var convert_date = temp_date.getMonth()+ 1 +"/"+ temp_date.getDate();
      var temp_str = convert_date.toString();
      dateArray.push(temp_str);
    }
    $scope.data.labels = dateArray;

    // Intake data
    // window.alert(dateArray);

    var new_table = { label: 'Weekly Intake',
         fillColor: 'rgba(151,187,205,0.5)',
         strokeColor: 'rgba(151,187,205,0.8)',
         highlightFill: 'rgba(151,187,205,0.75)',
         highlightStroke: 'rgba(151,187,205,1)',
         data: [0, 0, 0, 0, 0, 0, 0] };


    //get data -----------------------------------------------------

    // data API
    var ref = new Firebase('https://brilliant-torch-5432.firebaseio.com');

    var uid = localStorage.getItem("currentUser");
    var currentServe = 0;

    ref.child(uid).child("statistic").on('value',function(snap) {
      for (var i = 6; i >= 0; i--){
        var today = new Date();
        today.setDate(today.getDate() - i);
        var month = (today.getMonth() - (-1));
        if (month < 10) month = "0" + month;
        var date = today.getDate();
        if (date < 10) date = "0" + date;
    
        var date = today.getFullYear() + "-" + month+ "-" + date;

        currentServe = snap.child(date).child('current').val();

        if (currentServe == null) {
          currentServe = 0;
        }
        new_table.data[6-i] = currentServe;
        $scope.data.datasets[0] = new_table;
      }
    });

    
    //get today time stamp
    // var now = new Date();
    //var tomorrow = now+1;
    

    

    // window.alert(currentServe);

    //customise options of the table
    $scope.options =  {

      // Sets the chart to be responsive
      responsive: true,

      //Boolean - Whether the scale should start at zero, or an order of magnitude down from the lowest value
      scaleBeginAtZero : true,

      //Boolean - Whether grid lines are shown across the chart
      scaleShowGridLines : true,

      //String - Colour of the grid lines
      scaleGridLineColor : "rgba(0,0,0,.05)",

      //Number - Width of the grid lines
      scaleGridLineWidth : 1,

      //Boolean - If there is a stroke on each bar
      barShowStroke : true,

      //Number - Pixel width of the bar stroke
      barStrokeWidth : 2,

      //Number - Spacing between each of the X value sets
      barValueSpacing : 10,

      //Number - Spacing between data sets within X values
      barDatasetSpacing : 1,

      //String - A legend template
      legendTemplate : '<ul class="tc-chart-js-legend"><% for (var i=0; i<datasets.length; i++){%><li><span style="background-color:<%=datasets[i].fillColor%>"></span><%if(datasets[i].label){%><%=datasets[i].label%><%}%></li><%}%></ul>'
    };

  });