angular.module('starter.controllers', [])

.controller('GameCtrl', function($scope) {

})

.controller('GuideCtrl', function($scope,$ionicPopup) {
  $scope.showPopup = function() {
   $scope.data = {}

   // An elaborate, custom popup
   var myPopup = $ionicPopup.alert({
      title: 'Introduction about Serve',
      template: 'Serve is ...'
   });
   myPopup.then(function(res) {
      console.log('Gerve Description');
   });
   // $timeout(function() {
   //    myPopup.close(); //close the popup after 3 seconds for some reason
   // }, 10000);
  };
})

.controller('AdminCtrl', function($scope) {
  var ref = new Firebase('https://brilliant-torch-5432.firebaseio.com');
  $scope.veges = [];
  $scope.fileName;

  // watch the new file input
  var fileInput = document.getElementById('image-input');
  fileInput.onchange = function () {
    for (var i = 0; i < fileInput.files.length; i++) {
      var fileUrl = window.URL.createObjectURL(fileInput.files[i]);
      convertImgToBase64(fileUrl, function(image){
        $scope.$apply(function () {
          var length = $scope.veges.length;
          $scope.veges.push({text: "", img: image, index: length});
        });
      });
    }
  }

  // get vegetables in the firebase
  ref.child("vegeList").child("vegeImg").once("value", function (snapshot) {
    $scope.veges = [];
    snapshot.forEach(function (vege) {
      $scope.$apply(function () {
        var length = $scope.veges.length;
        $scope.veges.push({text: vege.key(), img: vege.val(), index: length});
      });
    })
  })

  // delete a vegetable locally
  $scope.deleteVege = function (index) {
    $scope.veges.splice(index, 1);
    for (var i = index; i < $scope.veges.length; i++) {
      $scope.veges[i].index = i;
    }
  }

  // confirm change
  $scope.confirm = function (index) {
    var vegeImgs = {};
    for (var i = 0; i < $scope.veges.length; i++) {
      var vegeName = document.getElementById(i + "").value;
      if (vegeName == "") {
        alert("Please type a name for all of your vegetables!");
        return;
      }
      vegeImgs[vegeName] = $scope.veges[i].img;
    }
    ref.child("vegeList").child("vegeImg").set(vegeImgs, function (error) {
      var vegeNames = {};
      for (var i = 0; i < $scope.veges.length; i++) {
        var vegeName = document.getElementById(i + "").value;
        vegeNames[i + ""] = vegeName;
      }
      vegeNames["numberOfVeges"] = $scope.veges.length;
      ref.child("vegeList").child("vegeName").set(vegeNames, function (error) {
        window.location.href = "admin.html";
      });
    });
  }
})

.controller('HomeCtrl', function($scope, $ionicPopup) {
  // initialize properties, e.g. white box
  var ref = new Firebase('https://brilliant-torch-5432.firebaseio.com');
  initialHome(ref, $ionicPopup);
})

.controller('LoginCtrl', function($scope) {})

.controller('SettingCtrl', function($scope, $ionicPopup) {
  $scope.logout = function () {
    var confirmPopup = $ionicPopup.confirm({
      template: 'Are you sure to log out?',
      okType: 'button-balanced'
    });
    confirmPopup.then(function(res) {
      if(res) {
        localStorage.removeItem("currentUser");
        window.location.href = "index.html";
      }
    });
  }
})

// dairy controller
.controller('diaryCtrl', function($scope, $ionicPopup) {
  
  window.checkLogin($scope, $ionicPopup);

  window.showMoodModifyHistory();
  window.showSkinModifyHistory();
  window.showWeightModifyHistory();
  window.showEnergyModifyHistory();

  $scope.showConfirm = function() {

    var confirmPopup = $ionicPopup.confirm({
      template: 'Are you sure to confirm?',
      okType : 'button-balanced'
    });
    confirmPopup.then(function(res) {
      if(res) {
        getInformation();    
      }
    });
  }
})

.controller('AchievementCtrl', function($scope) {
  $scope.data = {};
  var ref = new Firebase('https://brilliant-torch-5432.firebaseio.com');
  checkAchievements(ref);
})

.controller('ChatsCtrl', function($scope, Chats) {

})

.controller('ChatDetailCtrl', function($scope, $stateParams, Chats) {
  $scope.chat = Chats.get($stateParams.chatId);
})

.controller('VegeCtrl', function($rootScope, $scope, $ionicPopup) {
  var userId = localStorage.getItem("currentUser");
  var myDataRef = new Firebase('https://brilliant-torch-5432.firebaseio.com');
  var user = myDataRef.child(userId);

  $scope.data = {};
  $scope.items = [];
  $scope.newItems = [];
  $scope.intakes = [];
  $scope.displayIndex = 0;
  $scope.deleteVisible = false;
  $scope.intakeAmount = 0;
  var today = getToday();

  myDataRef.child("vegeList").child("vegeName").once("value", function (snapshot1) {
    user.child("vegeList").once("value", function (snapshot2) {
      var vegeList = {};
      vegeList["numberOfVeges"] = snapshot2.child("numberOfVeges").val();
      var numberOfVeges = snapshot1.child("numberOfVeges").val();

      // read all the vegetables in the global area
      for (var i = 0; i < numberOfVeges; i++) {
        var vegeName = snapshot1.child(i + "").val();
        // if vegetable does not exist in user vege list, then add a new vegetable
        if (snapshot2.child(vegeName).val() == null) {
          vegeList[vegeName] = 0;
          if (localStorage.getItem(vegeName) == null) {
            $scope.newItems.push(vegeName);
          }
        }
        else {
          vegeList[vegeName] = snapshot2.child(vegeName).val();
          if (localStorage.getItem(vegeName) == null) {
            $scope.newItems.push(vegeName);
          }
        }
      }

      user.child("vegeList").set(vegeList, function (error) {
        // if there is any new item, we update localStorage then update scope
        if ($scope.newItems.length != 0) {
          myDataRef.child("vegeList").child("vegeImg").once("value", function (snapshot) {
            for (var i = 0; i < $scope.newItems.length; i++) {
              var vegeName = $scope.newItems[i];
              var img = snapshot.child(vegeName).val();
              localStorage.setItem(vegeName, img);
            }

            $scope.getUserVege();
          });
        }
        // else we update scope directly
        else {
          $scope.getUserVege();
        }
      });
    });
  });

  $scope.getUserVege = function () {
    user.child("vegeList").orderByValue().once("value", function (snapshot) {
      snapshot.forEach (function (vege) {
        if (vege.key() != "numberOfVeges") {
          $scope.$apply(function() {
            $scope.items.push({text: vege.key(), img: localStorage.getItem(vege.key())});
          });
        }
      });
    });
  }

  $scope.decreaseDisplayIndex = function() {
    $scope.displayIndex -= 4;
    if ($scope.displayIndex == 0) {
      document.getElementById("arrow-left").style.visibility = "hidden";
    }
    document.getElementById("arrow-right").style.visibility = "visible";
  }

  $scope.increaseDisplayIndex = function() {
    $scope.displayIndex += 4;
    if ($scope.displayIndex >= $rootScope.resultLength - 4) {
      document.getElementById("arrow-right").style.visibility = "hidden";
    }
    document.getElementById("arrow-left").style.visibility = "visible";
  }

  $scope.$watch('resultLength', function(newValue, oldValue) {
    $scope.displayIndex = 0;
    document.getElementById("arrow-left").style.visibility = "hidden";
    if (newValue <= 4) {
      document.getElementById("arrow-right").style.visibility = "hidden";
      document.getElementById("arrows").style.height = "0px";
    }
    else {
      document.getElementById("arrow-right").style.visibility = "visible";
      document.getElementById("arrows").style.height = "40px";
    }
  })

  $scope.showDelete = function() {
    var deleteButton = document.getElementsByClassName('delete');

    for (var i = 0; i < deleteButton.length; i++) {
      if (!$scope.deleteVisible) {
        deleteButton[i].style.visibility = "visible";
      }
      else {
        deleteButton[i].style.visibility = "hidden";
      }
    }

    $scope.deleteVisible = !$scope.deleteVisible;
  }

  $scope.deleteItem = function(vegeId, meal) {
    for (var i = 0; i < $scope.intakes.length; i++) {
      if ((vegeId == $scope.intakes[i].text) && (meal == $scope.intakes[i].meal)) {
        $scope.intakeAmount -= $scope.intakes[i].serve;
        $scope.intakes.splice(i, 1);
      }
    }
  }

  $scope.clearSearch = function() {
    $scope.data.searchQuery = '';
  };

  $scope.showPopup = function(vegeId, serve, meal) {
    // An elaborate, custom popup
    if (serve == "-1") {
      var placeholder = "e.g.1";
      var subTitle = "Please enter the amount:";
      var selectMeal = '<div id="mealSelection" class="row">Meal:&nbsp&nbsp&nbsp&nbsp&nbsp<select id="mealOptions"><option>Breakfast</option><option>Lunch</option><option>Dinner</option><option>Snack</option></select></div>';
    }
    else {
      var placeholder = serve;
      var subTitle = "Please update the amount:";
      var selectMeal = '';
    }

    var myPopup = $ionicPopup.show({
      template: '<div class="row"><input type="number" style="height: 20px; width: 150px;" ng-model="data.intake" min="0" max="100" placeholder=' + placeholder + '>Serve(s)</div>' + selectMeal,
      title: vegeId,
      subTitle: subTitle,
      scope: $scope,
      buttons: [
        { text: 'Cancel',
          onTap: function(e) {
            $scope.data.intake = '';
          }
        },
        {
          text: '<b>Confirm</b>',
          type: 'button-balanced',
          onTap: function(e) {
            if (!$scope.data.intake) {
              //don't allow the user to confirm if they do not enter numbers
              e.preventDefault();
            } else {
              if (serve == "-1") {
                var duplicated = false;
                var meals = document.getElementById("mealOptions");
                var selectedMeal = meals.options[meals.selectedIndex].text;

                for (var i = 0; i < $scope.intakes.length; i++) {
                  if ((vegeId == $scope.intakes[i].text) && (selectedMeal == $scope.intakes[i].meal)) {
                    $scope.intakes[i].serve += $scope.data.intake;
                    duplicated = true;
                  }
                }
  
                if (!duplicated) {
                  $scope.intakes.push({text: vegeId, img: localStorage.getItem(vegeId), serve: $scope.data.intake, meal: selectedMeal});
                  
                  var deleteButton = document.getElementsByClassName('delete');
                  for (var i = 0; i < deleteButton.length; i++) {
                    deleteButton[i].style.visibility = "hidden";
                  }
                }
  
                $scope.intakeAmount = $scope.intakeAmount - (-$scope.data.intake);
                $scope.intakeAmount = oneDecimal($scope.intakeAmount);
                $scope.data.intake = '';
                return $scope.data.intake;
              }
              else {
                for (var i = 0; i < $scope.intakes.length; i++) {
                  if ((vegeId == $scope.intakes[i].text) && (meal == $scope.intakes[i].meal)) {
                    $scope.intakeAmount = $scope.intakeAmount - $scope.intakes[i].serve - (-$scope.data.intake);
                    $scope.intakeAmount = oneDecimal($scope.intakeAmount);
                    $scope.intakes[i].serve = $scope.data.intake;
                  }
                }
                $scope.data.intake = '';
                return $scope.data.intake;
              }
            }
          }
        }
      ]
    });
  }

  $scope.showConfirm1 = function() {

    var confirmPopup = $ionicPopup.confirm({
      //title: 'Back',
      template: 'Are you sure to go back to home page?',

      okType: 'button-balanced'

    });
    confirmPopup.then(function(res) {
      if(res) {
        window.location = 'index.html#/tab/home';
      }
    });
  }

  $scope.showConfirm2 = function() {
    //connect to firebase --kelvin
    var confirmPopup = $ionicPopup.confirm({
      //title: 'Back',
      template: 'Are you sure to confirm the intakes?',
      okType: 'button-balanced'
    });
    confirmPopup.then(function(res) {
      if(res && $scope.intakeAmount > 0) {
        //update to firebase
        confirmIntake(user, today, $scope.intakes, $scope.intakeAmount);
      }
      else if (res && $scope.intakeAmount == 0) {
        alert("Please log some vegetables before confirming!")
      }
    });
  }
})

.filter('myFilter', function($filter, $rootScope) {
  return function(items, query) {
    var results = $filter('filter')(items, query)
    $rootScope.resultLength = results.length;
    return results;
  }
})

.controller('StatisticCtrl', function($scope) {
            //call draw intake js
            // window.drawsta();
})

.controller('GoalCtrl', function($scope, $ionicPopup) {
  var goalRef = new Firebase('https://brilliant-torch-5432.firebaseio.com');

  $scope.createReward = function (index) {
    localStorage.setItem("stage", index);
    window.location.href = "reward-setting.html";
  }

  $scope.confirmIni = function () {
    confirmGoal($ionicPopup, goalRef);
  }

  $scope.back = function () {
    back($ionicPopup, goalRef);
  }
})

.controller('RewardCtrl', function($scope, $rootScope, $ionicPopup, $ionicScrollDelegate) {
  var ref = new Firebase('https://brilliant-torch-5432.firebaseio.com');
  var currentUser = localStorage.getItem("currentUser");
  $scope.data = {};
  $scope.rewards = [];
  var myPopup;
  $scope.icon = "icon ion-help-circled";
  $scope.visibility = {reward: "block", icon: "none"};
  var stage = localStorage.getItem("stage");
  if (stage == "1") {
      var exampleIcon = "icon ion-ios-book-outline";
      var exampleText = "New Book";
    }
    else if (stage == "2") {
      var exampleIcon = "icon ion-tshirt-outline";
      var exampleText = "New T-Shirt";
    }
    else if (stage == "3") {
      var exampleIcon = "icon ion-android-bicycle";
      var exampleText = "New Bicycle";
    }
    else {
      var exampleIcon = "icon ion-playstation";
      var exampleText = "New Playstation";
    }

  ref.child(currentUser).child("reward").once("value", function (snapshot) {
    $scope.rows = initialRows();
    $scope.icons = initialIcons();
    document.getElementById("title").innerHTML = "Stage " + stage + " Reward";
  
    document.getElementById("exampleIcon").className = exampleIcon;
    document.getElementById("exampleText").innerHTML = exampleText;

    if (snapshot.val() != null) {
      var length = snapshot.val().length;
      for (var i = 0; i < length; i++) {
        var reward = snapshot.child(i).val();

        $scope.$apply(function () {
          if (reward.stage1 == "true" || reward.stage2 == "true" || reward.stage3 == "true" || reward.stage4 == "true") {
            $scope.rewards.push({text: reward.text, icon: reward.icon, stage1: reward.stage1, stage2: reward.stage2, stage3: reward.stage3, stage4: reward.stage4, visibility: "hidden"});
          }
          else {
            $scope.rewards.push({text: reward.text, icon: reward.icon, stage1: reward.stage1, stage2: reward.stage2, stage3: reward.stage3, stage4: reward.stage4, visibility: "visible"});
          }
        })
      }
    }
  });

  $scope.addReward = function() {
    myPopup = $ionicPopup.show({
      template: '<h4>Icon:&nbsp&nbsp<i class={{icon}}></i>&nbsp&nbsp<button ng-click="selectIcon()">Set Icon</button></h4><input type="text" ng-model="data.reward">',
      title: 'New Reward',
      scope: $scope,
      buttons: [
        { text: 'Cancel' },
        {
          text: '<b>Create</b>',
          type: 'button-balanced',
          onTap: function(e) {
            if (!$scope.data.reward) {
              //don't allow the user to close unless he enters serves
              e.preventDefault();
            } else {
              var duplicated = false;

              for (var i = 0; i < $scope.rewards.length; i++) {
                if ($scope.rewards[i].text == $scope.data.reward) {
                  duplicated = true;
                }
              }

              if (duplicated) {
                alert('Reward "' + $scope.data.reward + '" has already existed!');
                e.preventDefault();
              }
              else {
                $scope.rewards.push({text: $scope.data.reward, icon: $scope.icon, stage1: "false", stage2: "false", stage3: "false", stage4: "false"});
                $scope.data.reward = '';
                $scope.icon = "icon ion-help-circled";
              }
            }
          }
        }
      ]
    });
  }

  $scope.selectIcon = function () {
    $scope.visibility = {reward: "none", icon: "block"};
    myPopup.close();
  }

  $scope.deleteReward = function(text) {
    for (var i = 0; i < $scope.rewards.length; i++) {
      if ($scope.rewards[i].text == text) {
        $scope.rewards.splice(i, 1);
      }
    }
  }

  $scope.back = function() {
    if ($scope.visibility.reward == "block") {
      saveRewards($scope.rewards, ref);
    }
    else {
      $scope.visibility = {reward: "block", icon: "none"};
      $scope.addReward();
    }
  }

  $scope.leaveEmpty = function() {
    for (var i = 0; i < $scope.rewards.length; i++) {
      $scope.rewards[i]["stage" + stage] = "false";
    }

    ref.child(currentUser).child("stageReward").child(stage).set({
      content: ""
    }, function (error) {
      if (error) {
        alert(error);
      }
      else {
        saveRewards($scope.rewards, ref);
      }
    });
  }

  $scope.setExampleReward = function () {
    var currentUser = localStorage.getItem("currentUser");

    for (var i = 0; i < $scope.rewards.length; i++) {
      $scope.rewards[i]["stage" + stage] = "false";
    }

    ref.child(currentUser).child("stageReward").child(stage).set({
      content: exampleText,
      icon: exampleIcon
    }, function (error) {
      if (error) {
        alert(error);
      }
      else {
        saveRewards($scope.rewards, ref);
      }
    });
  }

  $scope.setReward = function(reward, icon) {
    var currentUser = localStorage.getItem("currentUser");

    for (var i = 0; i < $scope.rewards.length; i++) {
      if ($scope.rewards[i].text == reward) {
        $scope.rewards[i]["stage" + stage] = "true";
      }
      else {
        $scope.rewards[i]["stage" + stage] = "false";
      }
    }

    ref.child(currentUser).child("stageReward").child(stage).set({
      content: reward,
      icon: icon
    }, function (error) {
      if (error) {
        alert(error);
      }
      else {
        saveRewards($scope.rewards, ref);
      }
    });
  }

  $scope.clearSearch = function() {
    $scope.data.searchQuery = '';
  };

  $scope.chooseIcon = function (id) {
    for (var i = 0; i < $scope.icons.length; i++) {
      var icon = $scope.icons[i];
      if (icon.id == $scope.icon) {
        icon.shown = "button button-clear";
        icon.class = icon.shown + " " + icon.id;
      }
      if (icon.id == id) {
        icon.shown = "button button-clear button-dark";
        icon.class = icon.shown + " " + icon.id;
      }
    }
    $scope.icon = id;

    $scope.visibility = {reward: "block", icon: "none"};
    $scope.addReward();
    
    $ionicScrollDelegate.$getByHandle('myScroll').scrollTop(true);
  }
})

.controller('AccountCtrl', function($scope, $ionicActionSheet, $ionicPopup, $timeout) {

  var ref = new Firebase('https://brilliant-torch-5432.firebaseio.com');
  var authData = localStorage.getItem("currentUser")
  var dataRef = ref.child (authData).child("userDetails");
  //read data
  dataRef.child("dob").on("value", function(snapshot) {
    if (snapshot.val() != null) {
      $("#dob").html(snapshot.val());
    }
  })

  dataRef.child("name").on("value", function(snapshot) {
    if (snapshot.val() != null) {
      $("#name").html(snapshot.val());
    }
  })
  dataRef.child("gender").on("value", function(snapshot) {
    if (snapshot.val() != null) {
      $("#gender").html(snapshot.val());
      if (snapshot.val() == "Male") {
        document.getElementById("genderIcon").className = "icon ion-male";
      }
      else {
        document.getElementById("genderIcon").className = "icon ion-female";
      }
    }
  })
  dataRef.child("userweight").on("value", function(snapshot) {
    if (snapshot.val() != null) {
      $("#userweight").html(snapshot.val());
    }
  })
  dataRef.child("goalweight").on("value", function(snapshot) {
    if (snapshot.val() != null) {
      $("#goalweight").html(snapshot.val());
    }
  })
  // Triggered on a button click, or some other target
  $scope.showGenders = function() {
    var gender_show = $ionicActionSheet.show({
     buttons: [
       { text: 'Female'},
       { text: 'Male'}
     ],
     //destructiveText: 'Delete',
     titleText: 'Gender',
     cancelText: 'Cancel',
     buttonClicked: function(index) {
       if (index == 0)
       {
          $("#gender").html("Female");

          dataRef.update({gender: 'Female'});
       }
       else
       {
          $("#gender").html("Male");

          dataRef.update({gender: 'Male'});
       }
       return true;
     }

   });

  }

  $scope.showDOB = function() {
    $scope.user = {};
    $scope.user.dob = new Date();

    // An elaborate, custom popup
    var myPopup = $ionicPopup.show({
      template: '<input id="input_date" type="date" ng-model="user.dob">',
      title: 'Enter new date of birth',
      scope: $scope,
      buttons: [
        { text: 'Cancel' },
        {
          text: '<b>Save</b>',
          type: 'button-balanced',
          onTap: function(e) {
            if (($scope.user.dob).toDateString())
              return $scope.user.dob;
          }
        }
      ]
    });
    myPopup.then(function(res) {
      $("#dob").html($("#input_date").val());

      dataRef.update({dob: $("#input_date").val()});
    });
  };

  $scope.showName = function() {
    $scope.user = {}
    //$scope.user.username = "Tom"
    
    // An elaborate, custom popup
    var name_popup = $ionicPopup.show({
      
      template: '<input type="text" ng-model="user.username">',
      title: 'Enter new name',
      scope: $scope,
      buttons: [
        { text: 'Cancel' },
        {
          text: '<b>Save</b>',
          type: 'button-balanced',
          onTap: function(e) {
            return $scope.user.username;
          }
        }
      ]
      
    });
    //name = $scope.user.username;
    name_popup.then(function(res) {
      $("#name").html(res);

      dataRef.update({name: res});
    });
  };

  $scope.showWeight = function() {
    $scope.user = {}

    // An elaborate, custom popup
    var myPopup = $ionicPopup.show({
      template: '<input type="number" ng-model="user.weight">',
      title: 'Enter new weight',
      scope: $scope,
      buttons: [
        { text: 'Cancel' },
        {
          text: '<b>Save</b>',
          type: 'button-balanced',
          onTap: function(e) {
            return $scope.user.weight;
          }
        }
      ]
    });
    myPopup.then(function(res) {
      $("#userweight").html(res + "kg");

      dataRef.update({userweight: res + "kg"});
    });
  };

  $scope.showGoalWeight = function() {
    $scope.user = {}

    // An elaborate, custom popup
    var myPopup = $ionicPopup.show({
      template: '<input type="number" ng-model="user.g_weight">',
      title: 'Enter new goal weight',
      scope: $scope,
      buttons: [
        { text: 'Cancel' },
        {
          text: '<b>Save</b>',
          type: 'button-balanced',
          onTap: function(e) {
            return $scope.user.g_weight;
          }
        }
      ]
    });
    myPopup.then(function(res) {
      $("#goalweight").html(res + "kg");

      dataRef.update({goalweight: res + "kg"});
    });
  };
});
