
function getInformation() {

  var myDataRef = new Firebase('https://brilliant-torch-5432.firebaseio.com');
  var userId = localStorage.getItem("currentUser");
  var userOption = myDataRef.child(userId);
  var userDiary = userOption.child("diary");

  var now = new Date();
  var date = now.yyyymmdd();

  userOption.once("value", function(snapshot) {
    var array = [];
    
    var mood = snapshot.child("option").val().mood;
    var weight = snapshot.child("option").val().weight;
    var skin = snapshot.child("option").val().skin;
    var energyLevel = snapshot.child("option").val().energyLevel;

    // how to update 4 entries at the same time, the entries should be in different entry
    if (mood != null && document.getElementById("mood").value != "empty") {
        array.push("mood");
    }

    if (weight != null && document.getElementById("weight").value != "") {
        array.push("weight");
    }
    if (skin != null && document.getElementById("skin").value != "empty") {
        array.push("skin");
    }
    if (energyLevel != null && document.getElementById("energyLevel").value != "empty") {
        array.push("energyLevel");  
    }

    if (array.length == 0) {
      window.location = "index.html#tab/home";
    }

    var index = 0;
    helpMethod(userDiary, array, index, date),function(error) {
      
    }
  })
}

function helpMethod(userDiary, array, index, date) {
  var type = array[index];
  var value = document.getElementById(type).value;
  userDiary.child(type).push({
      type: value,
      time: date
      }, function(error) {
      if (error) {
      alert(error);
      }
      else {
      if (index - (-1) == array.length) {
        window.location = "index.html#tab/home";
      }
      else {
        index = index - (-1);
        helpMethod(userDiary, array, index, date);
      }
    }   
  });
}

function showMoodModifyHistory() {

    var myDataRef = new Firebase('https://brilliant-torch-5432.firebaseio.com');
    var userId = localStorage.getItem("currentUser");
    var userRef = myDataRef.child(userId).child("diary");


    myDataRef.child(userId).child("diary").child("mood").limitToLast(10).on('child_added', function (snapshot) {
    
    var messageList = $("#lastTimeMoodModify");
    //GET DATA
    var data = snapshot.val();
    var record = data.type;
    var time = data.time;

    //CREATE ELEMENTS MESSAGE & SANITIZE TEXT
    var messageElement = $("<a class='item'>");
    var nameElement = $("<strong name='moodModifyTime'></strong>")
    nameElement.text(time);
    messageElement.text(record).prepend(time);

    //ADD MESSAGE
    messageList.prepend(messageElement);
    messageList[0].scrollTop = messageList[0].scrollHeight;
  });
}

function showSkinModifyHistory() {

    var myDataRef = new Firebase('https://brilliant-torch-5432.firebaseio.com');
    var userId = localStorage.getItem("currentUser");
    var userRef = myDataRef.child(userId).child("diary");


    myDataRef.child(userId).child("diary").child("skin").limitToLast(10).on('child_added', function (snapshot) {
    
    var messageList = $("#lastTimeSkinModify");
    //GET DATA
    var data = snapshot.val();
    var record = data.type;
    var time = data.time;

    //CREATE ELEMENTS MESSAGE & SANITIZE TEXT
    var messageElement = $("<a class='item'>");
    var nameElement = $("<strong name='skinModifyTime'></strong>")
    nameElement.text(time);
    messageElement.text(record).prepend(time);

    //ADD MESSAGE
    messageList.prepend(messageElement);
    messageList[0].scrollTop = messageList[0].scrollHeight;
  });
}

function showWeightModifyHistory() {

    var myDataRef = new Firebase('https://brilliant-torch-5432.firebaseio.com');
    var userId = localStorage.getItem("currentUser");
    var userRef = myDataRef.child(userId).child("diary");


    myDataRef.child(userId).child("diary").child("weight").limitToLast(10).on('child_added', function (snapshot) {
    
    var messageList = $("#lastWeightTimeModify");
    //GET DATA
    var data = snapshot.val();
    var record = data.type;
    var time = data.time;

    //CREATE ELEMENTS MESSAGE & SANITIZE TEXT
    var messageElement = $("<a class='item'>");
    var nameElement = $("<strong name='weightModifyTime'></strong>")
    nameElement.text(time);
    messageElement.text(record).prepend(time);

    //ADD MESSAGE
    messageList.prepend(messageElement);
    messageList[0].scrollTop = messageList[0].scrollHeight;
  });
}

function showEnergyModifyHistory() {

    var myDataRef = new Firebase('https://brilliant-torch-5432.firebaseio.com');
    var userId = localStorage.getItem("currentUser");
    var userRef = myDataRef.child(userId).child("diary");


    myDataRef.child(userId).child("diary").child("energyLevel").limitToLast(10).on('child_added', function (snapshot) {
    
    var messageList = $("#lastEnergyTimeModify");
    //GET DATA
    var data = snapshot.val();
    var record = data.type;
    var time = data.time;

    //CREATE ELEMENTS MESSAGE & SANITIZE TEXT
    var messageElement = $("<a class='item'>");
    var nameElement = $("<strong class='energyModifyTime'></strong>")
    nameElement.text(time);
    messageElement.text(record).prepend(time);

    //ADD MESSAGE
    messageList.prepend(messageElement);
    messageList[0].scrollTop = messageList[0].scrollHeight;
  });
}


function checkLogin($scope, $ionicPopup) {

  var myDataRef = new Firebase('https://brilliant-torch-5432.firebaseio.com');
  var userId = localStorage.getItem("currentUser");
  var userOption = myDataRef.child(userId).child("option");
  var userRef = myDataRef.child(userId).child("diary");
  var userOption = myDataRef.child(userId);
  var checkOption = false;

  userOption.once("value", function(snapshot) {
    if (snapshot.child("option").val() == null) {
        checkOption =  true;
      }
        if (checkOption) {
        var name_popup = $ionicPopup.show({
        title: 'choice the information you want to record',
        template: '<li class="item item-checkbox checkbox-balanced"><label class="checkbox checkbox-balanced"><input type="checkbox" id="skinBox"></label>Skin</li><li class="item item-checkbox checkbox-balanced"><label class="checkbox"><input type="checkbox" id="weightBox"></label>Weight</li><li class="item item-checkbox checkbox-balanced"><label class="checkbox"><input type="checkbox" id="moodBox"></label>Mood</li><li class="item item-checkbox checkbox-balanced"><label class="checkbox"><input type="checkbox" id="energyLevelBox"></label>Energy Level</li>',
        scope: $scope,
        buttons:[
          {
            text: '<b>Confirm</b>',
            type: 'button-balanced',
            onTap: function(e) {
               if (document.getElementById('skinBox').checked == true) {
                  userOption.child("option").update({
                      skin: "1"
                  },function(error) {
                    
                  if (!error) {
                   document.getElementById("skinCard").style.display = "block";
                  }
                });
              }

              if (document.getElementById('weightBox').checked == true) {
                  userOption.child("option").update({
                      weight: "1"
                  },function(error) {
                    
                  if (!error) {
                    document.getElementById("weightCard").style.display = "block";
                  }
                });
              }

              if (document.getElementById('moodBox').checked == true) {
                  userOption.child("option").update({
                      mood: "1"
                  },function(error) {
                   
                  if (!error) {
                   document.getElementById("moodCard").style.display = "block";
                  }
                });
              }

              if (document.getElementById('energyLevelBox').checked == true) {
                  userOption.child("option").update({
                      energyLevel: "1"
                  },function(error) {
                    
                  if (!error) {
                    document.getElementById("energyLevelCard").style.display = "block";
                  }
                });
              }
            }
          }
        ]
      });
    }
    else {
      var mood = snapshot.child("option").val().mood;
      var weight = snapshot.child("option").val().weight;
      var skin = snapshot.child("option").val().skin;
      var energyLevel = snapshot.child("option").val().energyLevel;

      if (mood != null) {
        document.getElementById("moodCard").style.display = "block";
      }
      if (weight != null) {
        document.getElementById("weightCard").style.display = "block";
      }
      if (skin != null) {
        document.getElementById("skinCard").style.display = "block";
      }
      if (energyLevel != null) {
        document.getElementById("energyLevelCard").style.display = "block";
      }
    }
  })
}

Date.prototype.yyyymmdd = function() {
  // var yyyy = this.getFullYear().toString() +  "-";
  // var mm = (this.getMonth()+1).toString() + "-"; // getMonth() is zero-based
  // var dd  = this.getDate().toString() + " ";
  // return yyyy + (mm[1]?mm:"0"+mm[0]) + (dd[1]?dd:"0"+dd[0]); // padding

  var currentdate = new Date(); 
  var datetime = currentdate.getDate() + "/"
                + (currentdate.getMonth()+1)  + "/" 
                + currentdate.getFullYear() + " @ "  
                + currentdate.getHours() + ":"  
                + currentdate.getMinutes() + ":" 
                + currentdate.getSeconds() + " ";

  return datetime;
};
