function exportdata () {
	var ref = new Firebase('https://brilliant-torch-5432.firebaseio.com');
	//var uid = '3a8304b9-8fc2-4262-ad86-b8a8b5fa2611';
	
	var name,dob,age,gender,currentGoal,currentRecord,maxRecord;
	var now = new Date();
	var currentYear = now.getFullYear();
	var filename = "userDate.csv"
	var data = [];
	var entryname = ["uid","name","dob", "age", "gender","currentGoal","currentRecord","maxRecord"];
	data.push(entryname);
	ref.once('value', function(snap) {
		//alert()
		snap.forEach(function(ss) {
			var csventry = [];
			var uid = ss.key();
			name = ss.child("userDetails").child("name").val();
			dob = ss.child("userDetails").child("dob").val();
			age = currentYear - new Date(dob).getFullYear();
			gender = ss.child("userDetails").child("gender").val();
			currentGoal = ss.child("userDetails").child("goal").val();
			maxRecord = ss.child("userDetails").child("longest").val();
			currentRecord = ss.child("userDetails").child("current").val();
			csventry.push(uid);
			csventry.push(name);
			csventry.push(dob);
			csventry.push(age);
			csventry.push(gender);
			csventry.push(currentGoal);
			csventry.push(currentRecord);
			csventry.push(maxRecord);
			data.push(csventry);
		})
		//console.log(name+dob+"age"+age+gender+currentGoal+maxRecord);
		var file = convertArrayOfObjectsToCSV({data : data});
		downloadCSV({filename: "userDetails-data.csv" },file);
	})
}

function exportstatistic() {

	var ref = new Firebase('https://brilliant-torch-5432.firebaseio.com');
	//var uid = '3a8304b9-8fc2-4262-ad86-b8a8b5fa2611';
	
	var name,uid;
	var entry;
	var data = [];
	var entryname = ["uid","name","date","time","mealtime","vege type","serves","currentGoal"];
	data.push(entryname);
	ref.once('value', function(snap) {
		//uid = snap.child("userDetails").val()[name];
		//alert(snap.child('3a8304b9-8fc2-4262-ad86-b8a8b5fa2611').key());
		snap.forEach(function(ss) {
       		var what = ss.child("statistic").val();
       		if (what != null) {
			name = ss.child("userDetails").child("name").val();
			uid = ss.key();
			for(var key in what) {
				for (var entry in what[key]) {
					if (checkStatEntry(entry)) {
					//var test ="-K-Mrcn5eh4W3DkiF_qt";
						//for (var intake in what[key][entry])
						var systemtime = what[key][entry].time
						//var timestamp = convertTime(systemtime);
						//alert(timestamp+":"+systemtime);
						var date = new Date(systemtime);
						// hours part from the timestamp
						var hours = date.getHours();
						// minutes part from the timestamp
						var minutes = "0" + date.getMinutes();
						// seconds part from the timestamp
						var seconds = "0" + date.getSeconds();

						// will display time in 10:30:23 format
						var formattedTime = hours + ':' + minutes.substr(-2) + ':' + seconds.substr(-2);
						var currentGoal = what[key]["current"];
						
						//alert(formattedTime);
						//alert(JSON.stringify(what[key][entry]["Breakfast"]));
						//if (what[key][entry]["Breakfast"]!=null) {
						var csventry = [];
						for(var mealtime in what[key][entry]) {
							for(var vege in what[key][entry][mealtime]) {
								var serves = what[key][entry][mealtime][vege]["serve"];
								csventry.push(uid);
								csventry.push(name);
								csventry.push(key);
								csventry.push(formattedTime);
								csventry.push(mealtime);
								csventry.push(vege);
								csventry.push(serves);
								csventry.push(currentGoal);
								//alert(csventry);//vege and serves
								data.push(csventry);
							}
						}
						
					}
				}
			}
		}

    	});
		//alert(data);
		//var json = JSON.parse(what);
		var file = convertArrayOfObjectsToCSV({data : data});
		downloadCSV({filename: "statistic-data.csv" },file);
	});
	
	//alert(data);
	
}
function checkStatEntry(value){
	var irrelevent = ["current","goal","reachGoal","addDaily1","addDaily2"];
	return irrelevent.indexOf(value) <= -1;
}
function convertTime (timestamp) {
	var offsetRef = new Firebase("https://brilliant-torch-5432.firebaseio.com/.info/serverTimeOffset");
	var result;
	offsetRef.on("value", function(snap) {
       	var offset = snap.val();//4577
       	result = timestamp+offset;
	},function (error) {
		alert("cacac"+result);
		if (!error) return result;
	})
	return result;
}


function convertArrayOfObjectsToCSV(args) {  

    var result, ctr, keys, columnDelimiter, lineDelimiter, data;

    data = args.data || null;
    if (data == null || !data.length) {
        return null;
    }

    columnDelimiter = args.columnDelimiter || ',';
    lineDelimiter = args.lineDelimiter || '\n';

    keys = Object.keys(data[0]);

    result = '';
    result += keys.join(columnDelimiter);
    result += lineDelimiter;

    data.forEach(function(item) {
        ctr = 0;
        keys.forEach(function(key) {
            if (ctr > 0) result += columnDelimiter;

            result += item[key];
            ctr++;
        });
        result += lineDelimiter;
    });

    return result;
}
function downloadCSV(args,csv) {  
    var data, filename, link;
    // var csv = convertArrayOfObjectsToCSV({
    //     data: stockData
    // });
    if (csv == null) return;

    filename = args.filename || 'data.csv';
    //window.open("data:text/csv;charset=utf-8," + escape(csv));

    if (!csv.match(/^data:text\/csv/i)) {
        csv = 'data:text/csv;charset=utf-8,' + csv;
    }
    data = encodeURI(csv);

    link = document.createElement('a');
    link.setAttribute('href', data);
    link.setAttribute('download', filename);
    link.click();
}