function initialHome (ref, ionicPopup) {
  var currentUser = localStorage.getItem("currentUser");

  ref.child(currentUser).on("value", function(snapshot) {
    var today = getToday();
    
    var goalServe = snapshot.child("statistic").child(today).child("goal").val();
    if (goalServe == null) goalServe = snapshot.child("userDetails").val().goal;

    var currentServe = snapshot.child("statistic").child(today).child("current").val();
    if (currentServe == null) currentServe = 0;
    
    var percentage = Math.floor(currentServe * 100 / goalServe);
  
    // set the height of the white box
    var whiteBox = document.getElementById('white');
    if (percentage > 100) percentage = 100;
    whiteBox.style.height = (277 - 193 * percentage / 100) + "px";
  
    // set the contents of current serve
    var current = document.getElementById('currentServe');
    current.innerHTML = currentServe + "</br>" + (percentage + "%");
  
    // set the coordinate and contents of the goal
    var goal = document.getElementById('goalServe');
    var width = window.innerWidth;
    goal.style.left = (width / 2 + 50) + "px";
    goal.innerHTML = "Goal: " + goalServe + " Serve(s)";

    // set the meter
    var currentDays = snapshot.child("userDetails").val().current;
    var longest = snapshot.child("userDetails").val().longest;

    if (currentDays > 28) currentDays = 28;
    if (longest > 28) longest = 28;
    var length1 = (currentDays * 100 / 28) + "%";
    var length2 = ((longest - currentDays) * 100 / 28) + "%";
    document.getElementById("currentBar").style.width = length1;
    document.getElementById("maxBar").style.width = length2;

    // get the next reward
    var longest = snapshot.child("userDetails").val().longest;
    var closest = Math.floor(longest / 7) + 1;
    var nextReward;
    // finish all the stages
    if (closest > 4) {
      nextReward = "You have achieved all the rewards!";
      document.getElementById("nextRewardIcon").className = "icon ion-checkmark-circled";
    }
    else {
      while (closest <= 4) {
        var stageReward = snapshot.child("stageReward").child(closest).child("content").val();
        if (stageReward == null || stageReward == "") {
          closest++;
        }
        else {
          nextReward = "Next Reward (Stage " + closest + "): <br>" + stageReward;
          var nextRewardIcon = snapshot.child("stageReward").child(closest).child("icon").val();
          document.getElementById("nextRewardIcon").className = nextRewardIcon;
          break;
        }
      }

      if (closest > 4) {
        nextReward = "No futher reward available!";
        document.getElementById("nextRewardIcon").className = "icon ion-help-circled";
      }
    }
    
    document.getElementById("nextReward").innerHTML = nextReward;


    ref.child(currentUser).child("userDetails").update({
      newUser: "false"
    }, function (error) {
      var reachGoal = snapshot.child("statistic").child(today).child("reachGoal").val();

      // if user has just reached the daily goal, pop up and update the status
      if (reachGoal == "true") {
        var alertPopup = ionicPopup.alert({
          title: 'Congratulations!',
          template: 'You have reached the daily goal!<div class="row" id="stars"><img id="star1" src="img/star.png"><img id="star2" src="img/star.png"><img id="star3" src="img/star.png"></div>'
        });
    
        ref.child(currentUser).child("statistic").child(today).update({
          reachGoal: "poped"
        }, function (error1) {
          // if user did not reach the goal yesterday, we set the current consequent day to 0
          var yesterday = getYesterday();
          var yesterdayReachGoal = snapshot.child("statistic").child(yesterday).child("reachGoal").val();
          if (yesterdayReachGoal == "poped") {
            var currentDays = snapshot.child("userDetails").val().current;
          }
          else {
            var currentDays = "0";
          }

          var currentDays = currentDays - (-1);
          if (currentDays > longest) {
            longest = currentDays;
            if (longest % 7 == 0 && longest > 0 && longest <= 28) {
              alertPopup.then(function(res) {
                var reachedStage = Math.floor(longest / 7);
                var currentReward = snapshot.child("stageReward").child(reachedStage).child("content").val();

                if (currentReward != null) {
                  var alertPopup1 = ionicPopup.alert({
                    title: 'Congratulations',
                    template: 'You have reached your Stage ' + reachedStage + ' reward: <b>' + currentReward + "</b>"
                  });
                }
              });
            }
          }

          ref.child(currentUser).child("userDetails").update({
            current: currentDays + "",
            longest: longest + ""
          });
        });
      }
      else if (reachGoal == "false" || reachGoal == null) {
        var yesterday = getYesterday();
        var yesterdayReachGoal = snapshot.child("statistic").child(yesterday).child("reachGoal").val();
        if (yesterdayReachGoal != "poped") {
          ref.child(currentUser).child("userDetails").update({
            current: "0"
          });
        }
      }
    });
  }, function (error) {
    alert(error.code);
  })
};

// function for if the window is resized by the user
window.onresize = resize;
function resize () {
  var goal = document.getElementById('goalServe');
  var width = window.innerWidth;
  if (goal != null) goal.style.left = (width / 2 + 50) + "px";
}

function getToday () {
  var today = new Date();
  var month = (today.getMonth() - (-1));
  if (month < 10) month = "0" + month;
  var date = today.getDate();
  if (date < 10) date = "0" + date;

  var date = today.getFullYear() + "-" + month+ "-" + date;
  return date;
}

function getYesterday () {
  var yesterday = new Date();
  yesterday.setDate(yesterday.getDate() - 1);
  var month = (yesterday.getMonth() - (-1));
  if (month < 10) month = "0" + month;
  var date = yesterday.getDate();
  if (date < 10) date = "0" + date;

  var date = yesterday.getFullYear() + "-" + month+ "-" + date;
  return date;
}