'use strict';
angular
  .module( 'app.line', [] )
  .controller( 'LineCtrl', function ( $scope ) {

    $scope.data = {
      labels: ['Week1', 'Week2', 'Week3', 'Week4'],
      datasets: [
        {
          label: 'Monthly AverageGoal',
          fillColor: 'rgba(255,255,255,0.4)',
          strokeColor: 'rgba(211,247,208,0.8)',
          pointColor: 'rgba(164,224,185,1)',
          pointStrokeColor: '#fff',
          pointHighlightFill: '#fff',
          pointHighlightStroke: 'rgba(164,224,185,1)',
          data: [6, 6, 6, 6]
        },
        {
          label: 'Monthly Average Intake',
          fillColor: 'rgba(151,187,205,0.2)',
          strokeColor: 'rgba(151,187,205,1)',
          pointColor: 'rgba(151,187,205,1)',
          pointStrokeColor: '#fff',
          pointHighlightFill: '#fff',
          pointHighlightStroke: 'rgba(151,187,205,1)',
          data: [0, 0,0,0]
        },
        {
          label: 'Monthly AverageGoal',
          fillColor: 'rgba(255,255,255,0.4)',
          strokeColor: 'rgba(255,138,138,0.8)',
          pointColor: 'rgba(208,100,100,1)',
          pointStrokeColor: '#fff',
          pointHighlightFill: '#fff',
          pointHighlightStroke: 'rgba(208,100,100,1)',
          data: [0, 0, 0, 0]
        }
      ]
    };

    $scope.days = 0;
    $scope.maxWeek = 0;

    var new_table = {
          label: 'Monthly Intake',
          fillColor: 'rgba(151,187,205,0.2)',
          strokeColor: 'rgba(151,187,205,1)',
          pointColor: 'rgba(151,187,205,1)',
          pointStrokeColor: '#fff',
          pointHighlightFill: '#fff',
          pointHighlightStroke: 'rgba(151,187,205,1)',
          data: [0, 0, 0, 0]
    };

    var regi_date = new Date();
    var currentdate = new Date();
    var uid = localStorage.getItem("currentUser");
    

    //get days from firebase
    var ref = new Firebase('https://brilliant-torch-5432.firebaseio.com');

    ref.child(uid).child("userDetails").child("startDate").on('value', function(snap) {
         var start = snap.val();
         $scope.regi_date = start;
         var msPerDay = 8.64e7;
         // alert(start);
         var startdate = new Date(start);
         //var startday = startdate.getDate();
         var end = new Date(getToday());

         startdate.setHours(12,0,0);
         end.setHours(12,0,0);
         
         $scope.days = Math.round((end - startdate)/msPerDay) + 1;
         // $scope.startWeekday =  startdate.getDay();
         // alert($scope.days);
    });

    ref.child(uid).child("statistic").on('value',function(snap) {
      var dailytake = new Array();

      // push all the intakes into array
      for (var i = $scope.days - 1; i >= 0; i--){
        var today = new Date();
        today.setDate(today.getDate() - i);
        var month = (today.getMonth() - (-1));
        if (month < 10) month = "0" + month;
        var date = today.getDate();
        if (date < 10) date = "0" + date;
    
        var date = today.getFullYear() + "-" + month+ "-" + date;
        var currentServe = 0;

        currentServe = snap.child(date).child('current').val();

        if (currentServe == null) {
          currentServe = 0;
        }

        dailytake.push(currentServe);
      }

      var tempDays = $scope.days;
      var tempSum = 0;
      var counter = 0;
      // alert(tempDays);
      

      //calculate weeks
      if (tempDays <= 7){
        for (var i = 0; i < tempDays; i++){
          tempSum -= -dailytake[i];
        }
        var weekOneIntake = Number(tempSum / tempDays).toFixed(2);
        new_table.data[0] = weekOneIntake;
      }else{
        var i = 0;
        while ((i < 7) && (counter < $scope.days)){
          tempSum -= - dailytake[counter];
          counter++;
          i++;
          //alert(i);
          if (i == 7){
            i-= 7;
            var weekNo = parseInt(counter/7);
            var weekCompleteIntake = Number(tempSum / 7).toFixed(2);
            new_table.data[weekNo-1] = weekCompleteIntake;
            tempSum = 0;
          }else if (counter == $scope.days){
            var weekNo = parseInt(counter/7);
            var leftDays = Math.round($scope.days % 7);
            var weekIntake = Number(tempSum / leftDays).toFixed(2);
            new_table.data[weekNo] = weekIntake;
            $scope.maxWeek = weekNo - (-1);
          }
        }
      }

      //calculate average
      var newdata = (new_table.data[0] -(-new_table.data[1]))/2;
      
      var sumdata = 0;
      var validWeek = 0;
      $scope.data.datasets[1] = new_table;
      for (var i = 0; i < 4; i++){
        if (new_table.data[i]!= 0){
          sumdata -= -new_table.data[i];
          validWeek -= -1;
        }
      }
      
      var averagedata = sumdata / validWeek;
      // alert($scope.regi_date);

      var avgmonth = (regi_date.getMonth() - (-1));
      if (avgmonth < 10) avgmonth = "0" + avgmonth;

      for (var i = 0 ; i < 4;i++) {
        $scope.data.datasets[2].data[i] = averagedata;
      };

      var weekArray = new Array();
      var weekNum = $scope.maxWeek;
      if (weekNum < 4){
        weekNum = 4;
      }

      // get x-axis lables
      for (var i = 1; i <= weekNum; i++){
        var weekStr = "Week " + i;
        weekArray.push(weekStr);
      }
      $scope.data.labels = weekArray;
      

    });

    $scope.options =  {

      // Sets the chart to be responsive
      responsive: true,

      ///Boolean - Whether grid lines are shown across the chart
      scaleShowGridLines : true,

      //String - Colour of the grid lines
      scaleGridLineColor : 'rgba(0,0,0,.05)',

      //Number - Width of the grid lines
      scaleGridLineWidth : 1,

      //Boolean - Whether the line is curved between points
      bezierCurve : true,

      //Number - Tension of the bezier curve between points
      bezierCurveTension : 0.4,

      //Boolean - Whether to show a dot for each point
      pointDot : true,

      //Number - Radius of each point dot in pixels
      pointDotRadius : 4,

      //Number - Pixel width of point dot stroke
      pointDotStrokeWidth : 1,

      //Number - amount extra to add to the radius to cater for hit detection outside the drawn point
      pointHitDetectionRadius : 20,

      //Boolean - Whether to show a stroke for datasets
      datasetStroke : true,

      //Number - Pixel width of dataset stroke
      datasetStrokeWidth : 2,

      //Boolean - Whether to fill the dataset with a colour
      datasetFill : true,

      // Function - on animation progress
      onAnimationProgress: function(){},

      // Function - on animation complete
      onAnimationComplete: function(){},

      //String - A legend template
      legendTemplate : '<ul class="tc-chart-js-legend"><% for (var i=0; i<datasets.length; i++){%><li><span style="background-color:<%=datasets[i].strokeColor%>"></span><%if(datasets[i].label){%><%=datasets[i].label%><%}%></li><%}%></ul>'
    };

     $scope.getToday = function(){
          var today = new Date();
          var month = (today.getMonth() - (-1));
          if (month < 10) month = "0" + month;
            var date = today.getDate();
          if (date < 10) date = "0" + date;
            var date = today.getFullYear() + "-" + month+ "-" + date;
          return date;
     }

  });