function readData()
  {
    var ref = new Firebase('https://brilliant-torch-5432.firebaseio.com');
    var currentUser = localStorage.getItem("currentUser");

    ref.child(currentUser).on("value", function (snapshot) {
      var goal = snapshot.val().userDetails.goal;
      var goals = document.getElementById("goals");
      goals.selectedIndex = goal - 1;

      for (var i = 1; i <= 4; i++) {
        var content = snapshot.child("stageReward").child(i).val();
        if (content != null && content.content != "") {
          document.getElementById("reward" + i).innerHTML = content.content;
        }
      }
    }, function (error) {
      alert(error.code);
    })
  }

function getToday () {
  var today = new Date();
  var month = (today.getMonth() - (-1));
  if (month < 10) month = "0" + month;
  var date = today.getDate();
  if (date < 10) date = "0" + date;

  var date = today.getFullYear() + "-" + month+ "-" + date;
  return date;
}

function confirmGoal (ionicPopup, goalRef) {
  var currentUser = localStorage.getItem("currentUser");
  var goals = document.getElementById("goals");
  var goal = goals.options[goals.selectedIndex].text;
  var today = getToday();

  goalRef.child(currentUser).once("value", function (snapshot) {
    var originGoal = snapshot.child("userDetails").val().goal;
    var todayGoal = snapshot.child("statistic").child(today).child("goal").val();
    var newUser = snapshot.child("userDetails").val().newUser;

    goalRef.child(currentUser).child("userDetails").update({
      goal: goal
    }, function (error) {
      if (!error) {
        if (todayGoal == null) {
          goalRef.child(currentUser).child("statistic").child(today).update({
            goal: originGoal
          }, function (error) {
            if (!error) {
              alertChange(ionicPopup, originGoal, goal, newUser);
            }
          });
        }
        else {
          alertChange(ionicPopup, originGoal, goal, newUser);
        }
      }
    });
  })
}

function alertChange (ionicPopup, originGoal, goal, newUser) {
  if (originGoal != goal && newUser == "false") {
    var alertPopup = ionicPopup.alert({
      template: 'Your new goal "' + goal + ' serve(s)" will be valid from tomorrow!'
    });
    alertPopup.then(function(res) {
      window.location.href = "index.html#/tab/home";
    });
  }
  else {
    window.location.href = "index.html#/tab/home";
  }
}

function back (ionicPopup, goalRef) {
  var currentUser = localStorage.getItem("currentUser");
  goalRef.child(currentUser).child("userDetails").on("value", function (snapshot) {
    if (snapshot.val().newUser == "true") {
      window.location.href = "guide.html";
    }
    else {
      var confirmPopup = ionicPopup.confirm({
        //title: 'Back',
        template: 'Are you sure to go back to home page?'
      });
      confirmPopup.then(function(res) {
        if(res) {
          window.location = 'index.html#/tab/home';
        }
      });
    }
  })
}