// get one decimal position
function oneDecimal (number) {
  return Number(number * 1).toFixed(1);
}

// get the date of today in the format of XXXX-XX-XX
function getToday () {
  var today = new Date();
  var month = (today.getMonth() - (-1));
  if (month < 10) month = "0" + month;
  var date = today.getDate();
  if (date < 10) date = "0" + date;

  var date = today.getFullYear() + "-" + month+ "-" + date;
  return date;
}

// confirm the intake, add timestamp and amount to the firebase
function confirmIntake (user, today, intakes, newAmount) {
  var newStat = user.child("statistic").child(today).push({
      time: Firebase.ServerValue.TIMESTAMP,
      current: newAmount
  },function(error) {
    if (error) {
      alert(error);
    }
    if (!error) {
      logIntake(user, today, intakes, newAmount, 0, newStat.key());
    }
  })
}

// recuresively add a new kind of intake to the firebase
function logIntake (user, today, intakes, newAmount, index, key) {
  var intake = intakes[index];
  user.child("statistic").child(today).child(key).child(intake.meal).child(intake.text).update({
    serve: intake.serve,
  }, function(error) {
    if (error) {
      alert(error);
    }
    else {
      index++;
      if (index == intakes.length) {
        user.child("vegeList").once("value", function (snapshot) {
          var vegeList = snapshot.val();
          for (var i = 0; i < intakes.length; i++) {
            intake = intakes[i];
            if (vegeList[intake.text] == 0) {
              vegeList["numberOfVeges"] = vegeList["numberOfVeges"] + 1;
            }
            vegeList[intake.text] = vegeList[intake.text] - intake.serve;
          }
          user.child("vegeList").update(vegeList, function (error) {
            updateStatus(user, today, newAmount);
          });
        });
      }
      else {
        logIntake(user, today, intakes, newAmount, index, key)
      }
    }
  });
}

// update the daily "reachGoal", "goal" and "current"
function updateStatus (user, today, newAmount) {
  user.once("value", function (snapshot) {
    var goal = snapshot.child("statistic").child(today).val().goal;
    if (goal == null) goal = snapshot.child("userDetails").val().goal;

    var current = snapshot.child("statistic").child(today).val().current;
    if (current == null) current = 0;
    var current = current - (-newAmount);
    current = oneDecimal(current);

    var reachGoal = snapshot.child("statistic").child(today).val().reachGoal;
    if (reachGoal == null) reachGoal = "false";
    
    // if already poped
    if (reachGoal == "poped") {
      user.child("statistic").child(today).update({
        goal: goal,
        current: current
      }, function (error) {
        window.location.href = "index.html#tab/home";
      });
    }
    // if just reach goal
    else if (current >= goal && reachGoal == "false") {
      user.child("statistic").child(today).update({
        goal: goal,
        current: current,
        reachGoal: "true"
      }, function (error) {
        window.location.href = "index.html#tab/home";
      });
    }
    // if still not reach goal
    else {
      user.child("statistic").child(today).update({
        goal: goal,
        current: current,
        reachGoal: reachGoal
      }, function (error) {
        window.location.href = "index.html#tab/home";
      });
    }
  })
}

// convert image
function convertImgToBase64(url, callback, outputFormat){
  var img = new Image();
  img.crossOrigin = 'Anonymous';
  img.onload = function(){
      var canvas = document.createElement('CANVAS');
      var ctx = canvas.getContext('2d');
    canvas.height = this.height;
    canvas.width = this.width;
      ctx.drawImage(this,0,0);
      var dataURL = canvas.toDataURL(outputFormat || 'image/png');
      callback(dataURL);
      canvas = null; 
  };
  img.src = url;
}